/*
 * Read the 5 min load average from /proc/loadavg
 *
 *
 */
//--------------------------INCLUDES-------------------------------------------
#include <stdio.h>
#include <string.h>

//--------------------------DEFINES--------------------------------------------

#define PROC_LOAD "/proc/loadavg"

// Return the load average as a percent
int getLoadAve()
{
	FILE *fd;
	char loadStr[80],*ptr;
	int len,n;

	if( (fd = fopen(PROC_LOAD,"r")) == NULL )
	{
		fprintf(stderr,"Can't open /proc/loadavg\n");
		return -1;
	}

	if( fgets(loadStr,sizeof(loadStr)-1,fd) == NULL )
	{
		fprintf(stderr,"Can't read /proc/loadavg\n");
		fclose(fd);
		return -1;
	}

	len = strlen(loadStr);

	ptr = loadStr;
	for(n=0; n < len; n++)
	{
		if(*ptr++ == ' ')
		{
			break;
		}
	}		

	if( n == len )
	{
		fprintf(stderr,"Can't parse loadave\n");
		fclose(fd);
		return -1;
	}

//	Hundreds
	n = *ptr++ - '0';
	n *= 10;
//	Skip decimal point
	ptr++;
//	Tens
	n += *ptr++ - '0';
	n *= 10;
// Units
	n += *ptr - '0'; 

	fclose(fd);

//	We need 2 to be 100%

	n += 1;
	n /= 2;

	return n;
}
